#include <dune/common/bitsetvector.hh>
#include <dune/istl/bvector.hh>

using BitVector = Dune::BitSetVector<1>;
using SingletonVector = Dune::BlockVector<Dune::FieldVector<double, 1>>;
using Vector2 = Dune::BlockVector<Dune::FieldVector<double, 2>>;
using Vector3 = Dune::BlockVector<Dune::FieldVector<double, 3>>;

template class FrictionWriter<BitVector>;

template void FrictionWriter<BitVector>::writeInfo(SingletonVector const &alpha,
                                                   Vector2 const &u,
                                                   Vector2 const &v);
template void FrictionWriter<BitVector>::writeInfo(SingletonVector const &alpha,
                                                   Vector3 const &u,
                                                   Vector3 const &v);
