#ifndef DIM
#error DIM unset
#endif

#include <dune/common/fmatrix.hh>
#include <dune/common/fvector.hh>

#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wignored-qualifiers"
#include <dune/grid/alugrid.hh>
#pragma clang diagnostic pop

#include <dune/istl/bcrsmatrix.hh>
#include <dune/istl/bvector.hh>

#include <dune/tnnmg/nonlinearities/zerononlinearity.hh>
#include <dune/tnnmg/problem-classes/convexproblem.hh>

#include <dune/tectonic/globalnonlinearity.hh>
#include <dune/tectonic/myblockproblem.hh>
#include <dune/tnnmg/problem-classes/blocknonlineartnnmgproblem.hh>

using SmallVector = Dune::FieldVector<double, DIM>;
using SmallMatrix = Dune::FieldMatrix<double, DIM, DIM>;
using Vector = Dune::BlockVector<SmallVector>;
using Matrix = Dune::BCRSMatrix<SmallMatrix>;

using Grid = Dune::ALUGrid<DIM, DIM, Dune::simplex, Dune::nonconforming>;

template class SolverFactory<
    DIM, MyBlockProblem<
             ConvexProblem<Dune::GlobalNonlinearity<Matrix, Vector>, Matrix>>,
    Grid>;
template class SolverFactory<
    DIM, BlockNonlinearTNNMGProblem<
             ConvexProblem<ZeroNonlinearity<SmallVector, SmallMatrix>, Matrix>>,
    Grid>;
