#ifndef DIM
#error DIM unset
#endif

#include <dune/common/fmatrix.hh>
#include <dune/common/function.hh>
#include <dune/common/fvector.hh>
#include <dune/istl/bcrsmatrix.hh>
#include <dune/istl/bvector.hh>

using SmallVector = Dune::FieldVector<double, DIM>;
using SmallMatrix = Dune::FieldMatrix<double, DIM, DIM>;
using Matrix = Dune::BCRSMatrix<SmallMatrix>;
using Vector = Dune::BlockVector<SmallVector>;
using Function = Dune::VirtualFunction<double, double>;

template class Newmark<Vector, Matrix, Function, DIM>;
template class BackwardEuler<Vector, Matrix, Function, DIM>;
