#ifndef DIM
#error DIM unset
#endif

#include <dune/common/fmatrix.hh>
#include <dune/common/fvector.hh>

#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wignored-qualifiers"
#include <dune/grid/alugrid.hh>
#pragma clang diagnostic pop

#include <dune/istl/bvector.hh>

#include <dune/fufem/functionspacebases/p0basis.hh>
#include <dune/fufem/functionspacebases/p1nodalbasis.hh>

using SingletonVector = Dune::BlockVector<Dune::FieldVector<double, 1>>;

using SmallVector = Dune::FieldVector<double, DIM>;
using SmallMatrix = Dune::FieldMatrix<double, DIM, DIM>;
using Vector = Dune::BlockVector<SmallVector>;

using Grid = Dune::ALUGrid<DIM, DIM, Dune::simplex, Dune::nonconforming>;
using GridView = Grid::LeafGridView;
using P1Basis = P1NodalBasis<GridView, double>;
using MyP0Basis = P0Basis<GridView, double>;

template void writeVtk<P1Basis, MyP0Basis, Vector, SingletonVector>(
    P1Basis const &vertexBasis, Vector const &displacement,
    SingletonVector const &logState, MyP0Basis const &cellBasis,
    SingletonVector const &stress, std::string const &filename);
